diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/install-sh 14-STYMulator-0.21a_configure+oss_support/install-sh
--- 13-STYMulator-0.21a-fail_on_bogus_data/install-sh	1970-01-01 01:00:00.000000000 +0100
+++ 14-STYMulator-0.21a_configure+oss_support/install-sh	2010-04-24 01:28:13.145630249 +0200
@@ -0,0 +1,519 @@
+#!/bin/sh
+# install - install a program, script, or datafile
+
+scriptversion=2006-12-25.00
+
+# This originates from X11R5 (mit/util/scripts/install.sh), which was
+# later released in X11R6 (xc/config/util/install.sh) with the
+# following copyright and license.
+#
+# Copyright (C) 1994 X Consortium
+#
+# Permission is hereby granted, free of charge, to any person obtaining a copy
+# of this software and associated documentation files (the "Software"), to
+# deal in the Software without restriction, including without limitation the
+# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
+# sell copies of the Software, and to permit persons to whom the Software is
+# furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included in
+# all copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
+# X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
+# AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNEC-
+# TION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+#
+# Except as contained in this notice, the name of the X Consortium shall not
+# be used in advertising or otherwise to promote the sale, use or other deal-
+# ings in this Software without prior written authorization from the X Consor-
+# tium.
+#
+#
+# FSF changes to this file are in the public domain.
+#
+# Calling this script install-sh is preferred over install.sh, to prevent
+# `make' implicit rules from creating a file called install from it
+# when there is no Makefile.
+#
+# This script is compatible with the BSD install script, but was written
+# from scratch.
+
+nl='
+'
+IFS=" ""	$nl"
+
+# set DOITPROG to echo to test this script
+
+# Don't use :- since 4.3BSD and earlier shells don't like it.
+doit=${DOITPROG-}
+if test -z "$doit"; then
+  doit_exec=exec
+else
+  doit_exec=$doit
+fi
+
+# Put in absolute file names if you don't have them in your path;
+# or use environment vars.
+
+chgrpprog=${CHGRPPROG-chgrp}
+chmodprog=${CHMODPROG-chmod}
+chownprog=${CHOWNPROG-chown}
+cmpprog=${CMPPROG-cmp}
+cpprog=${CPPROG-cp}
+mkdirprog=${MKDIRPROG-mkdir}
+mvprog=${MVPROG-mv}
+rmprog=${RMPROG-rm}
+stripprog=${STRIPPROG-strip}
+
+posix_glob='?'
+initialize_posix_glob='
+  test "$posix_glob" != "?" || {
+    if (set -f) 2>/dev/null; then
+      posix_glob=
+    else
+      posix_glob=:
+    fi
+  }
+'
+
+posix_mkdir=
+
+# Desired mode of installed file.
+mode=0755
+
+chgrpcmd=
+chmodcmd=$chmodprog
+chowncmd=
+mvcmd=$mvprog
+rmcmd="$rmprog -f"
+stripcmd=
+
+src=
+dst=
+dir_arg=
+dst_arg=
+
+copy_on_change=false
+no_target_directory=
+
+usage="\
+Usage: $0 [OPTION]... [-T] SRCFILE DSTFILE
+   or: $0 [OPTION]... SRCFILES... DIRECTORY
+   or: $0 [OPTION]... -t DIRECTORY SRCFILES...
+   or: $0 [OPTION]... -d DIRECTORIES...
+
+In the 1st form, copy SRCFILE to DSTFILE.
+In the 2nd and 3rd, copy all SRCFILES to DIRECTORY.
+In the 4th, create DIRECTORIES.
+
+Options:
+     --help     display this help and exit.
+     --version  display version info and exit.
+
+  -c            (ignored)
+  -C            install only if different (preserve the last data modification time)
+  -d            create directories instead of installing files.
+  -g GROUP      $chgrpprog installed files to GROUP.
+  -m MODE       $chmodprog installed files to MODE.
+  -o USER       $chownprog installed files to USER.
+  -s            $stripprog installed files.
+  -t DIRECTORY  install into DIRECTORY.
+  -T            report an error if DSTFILE is a directory.
+
+Environment variables override the default commands:
+  CHGRPPROG CHMODPROG CHOWNPROG CMPPROG CPPROG MKDIRPROG MVPROG
+  RMPROG STRIPPROG
+"
+
+while test $# -ne 0; do
+  case $1 in
+    -c) ;;
+
+    -C) copy_on_change=true;;
+
+    -d) dir_arg=true;;
+
+    -g) chgrpcmd="$chgrpprog $2"
+	shift;;
+
+    --help) echo "$usage"; exit $?;;
+
+    -m) mode=$2
+	case $mode in
+	  *' '* | *'	'* | *'
+'*	  | *'*'* | *'?'* | *'['*)
+	    echo "$0: invalid mode: $mode" >&2
+	    exit 1;;
+	esac
+	shift;;
+
+    -o) chowncmd="$chownprog $2"
+	shift;;
+
+    -s) stripcmd=$stripprog;;
+
+    -t) dst_arg=$2
+	shift;;
+
+    -T) no_target_directory=true;;
+
+    --version) echo "$0 $scriptversion"; exit $?;;
+
+    --)	shift
+	break;;
+
+    -*)	echo "$0: invalid option: $1" >&2
+	exit 1;;
+
+    *)  break;;
+  esac
+  shift
+done
+
+if test $# -ne 0 && test -z "$dir_arg$dst_arg"; then
+  # When -d is used, all remaining arguments are directories to create.
+  # When -t is used, the destination is already specified.
+  # Otherwise, the last argument is the destination.  Remove it from $@.
+  for arg
+  do
+    if test -n "$dst_arg"; then
+      # $@ is not empty: it contains at least $arg.
+      set fnord "$@" "$dst_arg"
+      shift # fnord
+    fi
+    shift # arg
+    dst_arg=$arg
+  done
+fi
+
+if test $# -eq 0; then
+  if test -z "$dir_arg"; then
+    echo "$0: no input file specified." >&2
+    exit 1
+  fi
+  # It's OK to call `install-sh -d' without argument.
+  # This can happen when creating conditional directories.
+  exit 0
+fi
+
+if test -z "$dir_arg"; then
+  trap '(exit $?); exit' 1 2 13 15
+
+  # Set umask so as not to create temps with too-generous modes.
+  # However, 'strip' requires both read and write access to temps.
+  case $mode in
+    # Optimize common cases.
+    *644) cp_umask=133;;
+    *755) cp_umask=22;;
+
+    *[0-7])
+      if test -z "$stripcmd"; then
+	u_plus_rw=
+      else
+	u_plus_rw='% 200'
+      fi
+      cp_umask=`expr '(' 777 - $mode % 1000 ')' $u_plus_rw`;;
+    *)
+      if test -z "$stripcmd"; then
+	u_plus_rw=
+      else
+	u_plus_rw=,u+rw
+      fi
+      cp_umask=$mode$u_plus_rw;;
+  esac
+fi
+
+for src
+do
+  # Protect names starting with `-'.
+  case $src in
+    -*) src=./$src;;
+  esac
+
+  if test -n "$dir_arg"; then
+    dst=$src
+    dstdir=$dst
+    test -d "$dstdir"
+    dstdir_status=$?
+  else
+
+    # Waiting for this to be detected by the "$cpprog $src $dsttmp" command
+    # might cause directories to be created, which would be especially bad
+    # if $src (and thus $dsttmp) contains '*'.
+    if test ! -f "$src" && test ! -d "$src"; then
+      echo "$0: $src does not exist." >&2
+      exit 1
+    fi
+
+    if test -z "$dst_arg"; then
+      echo "$0: no destination specified." >&2
+      exit 1
+    fi
+
+    dst=$dst_arg
+    # Protect names starting with `-'.
+    case $dst in
+      -*) dst=./$dst;;
+    esac
+
+    # If destination is a directory, append the input filename; won't work
+    # if double slashes aren't ignored.
+    if test -d "$dst"; then
+      if test -n "$no_target_directory"; then
+	echo "$0: $dst_arg: Is a directory" >&2
+	exit 1
+      fi
+      dstdir=$dst
+      dst=$dstdir/`basename "$src"`
+      dstdir_status=0
+    else
+      # Prefer dirname, but fall back on a substitute if dirname fails.
+      dstdir=`
+	(dirname "$dst") 2>/dev/null ||
+	expr X"$dst" : 'X\(.*[^/]\)//*[^/][^/]*/*$' \| \
+	     X"$dst" : 'X\(//\)[^/]' \| \
+	     X"$dst" : 'X\(//\)$' \| \
+	     X"$dst" : 'X\(/\)' \| . 2>/dev/null ||
+	echo X"$dst" |
+	    sed '/^X\(.*[^/]\)\/\/*[^/][^/]*\/*$/{
+		   s//\1/
+		   q
+		 }
+		 /^X\(\/\/\)[^/].*/{
+		   s//\1/
+		   q
+		 }
+		 /^X\(\/\/\)$/{
+		   s//\1/
+		   q
+		 }
+		 /^X\(\/\).*/{
+		   s//\1/
+		   q
+		 }
+		 s/.*/./; q'
+      `
+
+      test -d "$dstdir"
+      dstdir_status=$?
+    fi
+  fi
+
+  obsolete_mkdir_used=false
+
+  if test $dstdir_status != 0; then
+    case $posix_mkdir in
+      '')
+	# Create intermediate dirs using mode 755 as modified by the umask.
+	# This is like FreeBSD 'install' as of 1997-10-28.
+	umask=`umask`
+	case $stripcmd.$umask in
+	  # Optimize common cases.
+	  *[2367][2367]) mkdir_umask=$umask;;
+	  .*0[02][02] | .[02][02] | .[02]) mkdir_umask=22;;
+
+	  *[0-7])
+	    mkdir_umask=`expr $umask + 22 \
+	      - $umask % 100 % 40 + $umask % 20 \
+	      - $umask % 10 % 4 + $umask % 2
+	    `;;
+	  *) mkdir_umask=$umask,go-w;;
+	esac
+
+	# With -d, create the new directory with the user-specified mode.
+	# Otherwise, rely on $mkdir_umask.
+	if test -n "$dir_arg"; then
+	  mkdir_mode=-m$mode
+	else
+	  mkdir_mode=
+	fi
+
+	posix_mkdir=false
+	case $umask in
+	  *[123567][0-7][0-7])
+	    # POSIX mkdir -p sets u+wx bits regardless of umask, which
+	    # is incompatible with FreeBSD 'install' when (umask & 300) != 0.
+	    ;;
+	  *)
+	    tmpdir=${TMPDIR-/tmp}/ins$RANDOM-$$
+	    trap 'ret=$?; rmdir "$tmpdir/d" "$tmpdir" 2>/dev/null; exit $ret' 0
+
+	    if (umask $mkdir_umask &&
+		exec $mkdirprog $mkdir_mode -p -- "$tmpdir/d") >/dev/null 2>&1
+	    then
+	      if test -z "$dir_arg" || {
+		   # Check for POSIX incompatibilities with -m.
+		   # HP-UX 11.23 and IRIX 6.5 mkdir -m -p sets group- or
+		   # other-writeable bit of parent directory when it shouldn't.
+		   # FreeBSD 6.1 mkdir -m -p sets mode of existing directory.
+		   ls_ld_tmpdir=`ls -ld "$tmpdir"`
+		   case $ls_ld_tmpdir in
+		     d????-?r-*) different_mode=700;;
+		     d????-?--*) different_mode=755;;
+		     *) false;;
+		   esac &&
+		   $mkdirprog -m$different_mode -p -- "$tmpdir" && {
+		     ls_ld_tmpdir_1=`ls -ld "$tmpdir"`
+		     test "$ls_ld_tmpdir" = "$ls_ld_tmpdir_1"
+		   }
+		 }
+	      then posix_mkdir=:
+	      fi
+	      rmdir "$tmpdir/d" "$tmpdir"
+	    else
+	      # Remove any dirs left behind by ancient mkdir implementations.
+	      rmdir ./$mkdir_mode ./-p ./-- 2>/dev/null
+	    fi
+	    trap '' 0;;
+	esac;;
+    esac
+
+    if
+      $posix_mkdir && (
+	umask $mkdir_umask &&
+	$doit_exec $mkdirprog $mkdir_mode -p -- "$dstdir"
+      )
+    then :
+    else
+
+      # The umask is ridiculous, or mkdir does not conform to POSIX,
+      # or it failed possibly due to a race condition.  Create the
+      # directory the slow way, step by step, checking for races as we go.
+
+      case $dstdir in
+	/*) prefix='/';;
+	-*) prefix='./';;
+	*)  prefix='';;
+      esac
+
+      eval "$initialize_posix_glob"
+
+      oIFS=$IFS
+      IFS=/
+      $posix_glob set -f
+      set fnord $dstdir
+      shift
+      $posix_glob set +f
+      IFS=$oIFS
+
+      prefixes=
+
+      for d
+      do
+	test -z "$d" && continue
+
+	prefix=$prefix$d
+	if test -d "$prefix"; then
+	  prefixes=
+	else
+	  if $posix_mkdir; then
+	    (umask=$mkdir_umask &&
+	     $doit_exec $mkdirprog $mkdir_mode -p -- "$dstdir") && break
+	    # Don't fail if two instances are running concurrently.
+	    test -d "$prefix" || exit 1
+	  else
+	    case $prefix in
+	      *\'*) qprefix=`echo "$prefix" | sed "s/'/'\\\\\\\\''/g"`;;
+	      *) qprefix=$prefix;;
+	    esac
+	    prefixes="$prefixes '$qprefix'"
+	  fi
+	fi
+	prefix=$prefix/
+      done
+
+      if test -n "$prefixes"; then
+	# Don't fail if two instances are running concurrently.
+	(umask $mkdir_umask &&
+	 eval "\$doit_exec \$mkdirprog $prefixes") ||
+	  test -d "$dstdir" || exit 1
+	obsolete_mkdir_used=true
+      fi
+    fi
+  fi
+
+  if test -n "$dir_arg"; then
+    { test -z "$chowncmd" || $doit $chowncmd "$dst"; } &&
+    { test -z "$chgrpcmd" || $doit $chgrpcmd "$dst"; } &&
+    { test "$obsolete_mkdir_used$chowncmd$chgrpcmd" = false ||
+      test -z "$chmodcmd" || $doit $chmodcmd $mode "$dst"; } || exit 1
+  else
+
+    # Make a couple of temp file names in the proper directory.
+    dsttmp=$dstdir/_inst.$$_
+    rmtmp=$dstdir/_rm.$$_
+
+    # Trap to clean up those temp files at exit.
+    trap 'ret=$?; rm -f "$dsttmp" "$rmtmp" && exit $ret' 0
+
+    # Copy the file name to the temp name.
+    (umask $cp_umask && $doit_exec $cpprog "$src" "$dsttmp") &&
+
+    # and set any options; do chmod last to preserve setuid bits.
+    #
+    # If any of these fail, we abort the whole thing.  If we want to
+    # ignore errors from any of these, just make sure not to ignore
+    # errors from the above "$doit $cpprog $src $dsttmp" command.
+    #
+    { test -z "$chowncmd" || $doit $chowncmd "$dsttmp"; } &&
+    { test -z "$chgrpcmd" || $doit $chgrpcmd "$dsttmp"; } &&
+    { test -z "$stripcmd" || $doit $stripcmd "$dsttmp"; } &&
+    { test -z "$chmodcmd" || $doit $chmodcmd $mode "$dsttmp"; } &&
+
+    # If -C, don't bother to copy if it wouldn't change the file.
+    if $copy_on_change &&
+       old=`LC_ALL=C ls -dlL "$dst"	2>/dev/null` &&
+       new=`LC_ALL=C ls -dlL "$dsttmp"	2>/dev/null` &&
+
+       eval "$initialize_posix_glob" &&
+       $posix_glob set -f &&
+       set X $old && old=:$2:$4:$5:$6 &&
+       set X $new && new=:$2:$4:$5:$6 &&
+       $posix_glob set +f &&
+
+       test "$old" = "$new" &&
+       $cmpprog "$dst" "$dsttmp" >/dev/null 2>&1
+    then
+      rm -f "$dsttmp"
+    else
+      # Rename the file to the real destination.
+      $doit $mvcmd -f "$dsttmp" "$dst" 2>/dev/null ||
+
+      # The rename failed, perhaps because mv can't rename something else
+      # to itself, or perhaps because mv is so ancient that it does not
+      # support -f.
+      {
+	# Now remove or move aside any old file at destination location.
+	# We try this two ways since rm can't unlink itself on some
+	# systems and the destination file might be busy for other
+	# reasons.  In this case, the final cleanup might fail but the new
+	# file should still install successfully.
+	{
+	  test ! -f "$dst" ||
+	  $doit $rmcmd -f "$dst" 2>/dev/null ||
+	  { $doit $mvcmd -f "$dst" "$rmtmp" 2>/dev/null &&
+	    { $doit $rmcmd -f "$rmtmp" 2>/dev/null; :; }
+	  } ||
+	  { echo "$0: cannot unlink or rename $dst" >&2
+	    (exit 1); exit 1
+	  }
+	} &&
+
+	# Now rename the file to the real destination.
+	$doit $mvcmd "$dsttmp" "$dst"
+      }
+    fi || exit 1
+
+    trap '' 0
+  fi
+done
+
+# Local variables:
+# eval: (add-hook 'write-file-hooks 'time-stamp)
+# time-stamp-start: "scriptversion="
+# time-stamp-format: "%:y-%02m-%02d.%02H"
+# time-stamp-end: "$"
+# End:
diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/Makefile 14-STYMulator-0.21a_configure+oss_support/Makefile
--- 13-STYMulator-0.21a-fail_on_bogus_data/Makefile	2010-04-23 15:06:20.370746264 +0200
+++ 14-STYMulator-0.21a_configure+oss_support/Makefile	2010-04-24 14:29:27.053608110 +0200
@@ -9,3 +9,6 @@
 
 clean:
 	$(MAKE) -C src clean
+
+dist:
+	$(RM) -R config.h Rules.make config.log autom4te.cache config.status
diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/Rules.make.in 14-STYMulator-0.21a_configure+oss_support/Rules.make.in
--- 13-STYMulator-0.21a-fail_on_bogus_data/Rules.make.in	1970-01-01 01:00:00.000000000 +0100
+++ 14-STYMulator-0.21a_configure+oss_support/Rules.make.in	2010-04-25 12:46:22.625234974 +0200
@@ -0,0 +1,18 @@
+@SET_MAKE@
+BINDIR=@BINDIR@
+
+CFLAGS=@CFLAGS@ -Wall -I$(TOPDIR)
+CXXFLAGS=@CXXFLAGS@ -Wall -I$(TOPDIR)
+
+CC=@CC@ 
+CC=@CXX@
+INSTALL = @INSTALL@
+
+HAVE_LZH=@HAVE_LZH@
+HAVE_ALSA=@HAVE_ALSA@
+HAVE_OSS=@HAVE_OSS@
+ALSA_LIBS=@ALSA_LIBS@
+ALSA_CFLAGS=@ALSA_CFLAGS@
+
+AR = ar cr
+RM = rm -f
diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/src/Makefile 14-STYMulator-0.21a_configure+oss_support/src/Makefile
--- 13-STYMulator-0.21a-fail_on_bogus_data/src/Makefile	2010-04-23 15:06:20.375708920 +0200
+++ 14-STYMulator-0.21a_configure+oss_support/src/Makefile	2010-04-25 12:59:47.549581246 +0200
@@ -4,35 +4,40 @@
 LZH = stsoundlib/lzh
 STLIB = stsoundlib
 
-override CFLAGS += -I$(LZH) -I$(STLIB)
-override CXXFLAGS += -I$(LZH) -I$(STLIB)
+override CFLAGS += -I$(LZH) -I$(STLIB) $(ALSA_CFLAGS)
+override CXXFLAGS += -I$(LZH) -I$(STLIB) $(ALSA_CFLAGS)
 override LDFLAGS += -L$(LZH) -L$(STLIB)
 
-INSTALL = /usr/bin/install -c
-
 all: libs ymplayer ym2wav
 
+LIBS=-lym
+DIRS=$(STLIB)
+ifeq ($(HAVE_LZH),1)
+DIRS+=$(LZH)
+LIBS+=-llzh
+endif
+
 libs:
-	@for subdir in $(STLIB) $(LZH); do \
+	@for subdir in $(DIRS); do \
 	(cd $$subdir && make) || exit 1; \
 	done
 
 ymplayer: ymplayer.o sound.o ui.o
-	$(CXX) -o ymplayer $(LDFLAGS) ymplayer.o sound.o ui.o -lasound -lym -llzh -lncurses
+	$(CXX) -o ymplayer $(LDFLAGS) ymplayer.o sound.o ui.o $(ALSA_LIBS) $(LIBS) -lncurses
 
 ym2wav: ym2wav.o
-	$(CXX) -o ym2wav $(LDFLAGS) ym2wav.o -lym -llzh	
+	$(CXX) -o ym2wav $(LDFLAGS) ym2wav.o $(LIBS)
 
-ymplayer.o: ymplayer.cpp
-	$(CXX) $(CXXFLAGS) -c ymplayer.cpp
+ymplayer.o: ymplayer.cpp $(TOPDIR)/config.h
+	$(CXX) $(CXXFLAGS) $(ALSA_CFLAGS) -c ymplayer.cpp
 
-ym2wav.o: ym2wav.cpp $(STLIB)/StSoundLibrary.h
+ym2wav.o: ym2wav.cpp $(STLIB)/StSoundLibrary.h $(TOPDIR)/config.h
 	$(CXX) $(CXXFLAGS) $(INCLUDE) -c ym2wav.cpp
 
-sound.o: sound.cpp sound.h
-	$(CXX) $(CXXFLAGS) -c sound.cpp
+sound.o: sound.cpp sound.h $(TOPDIR)/config.h
+	$(CXX) $(CXXFLAGS) $(ALSA_CFLAGS) -c sound.cpp
 
-ui.o: ui.cpp ui.h $(STLIB)/StSoundLibrary.h
+ui.o: ui.cpp ui.h $(STLIB)/StSoundLibrary.h $(TOPDIR)/config.h
 	$(CXX) $(CXXFLAGS) -c ui.cpp
 
 install: all
@@ -41,7 +46,7 @@
 
 clean:
 
-	@for subdir in $(LZH) $(STLIB); do \
+	@for subdir in $(DIRS); do \
 	(cd $$subdir && make $@) || exit 1; \
 	done
 
diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/src/sound.cpp 14-STYMulator-0.21a_configure+oss_support/src/sound.cpp
--- 13-STYMulator-0.21a-fail_on_bogus_data/src/sound.cpp	2010-04-21 19:03:35.121472984 +0200
+++ 14-STYMulator-0.21a_configure+oss_support/src/sound.cpp	2010-04-24 01:48:25.710206456 +0200
@@ -25,17 +25,27 @@
  *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ---------------------------------------------------------------------------*/
 
+#include "config.h"
 #include "sound.h"
-
-snd_pcm_format_t format = SND_PCM_FORMAT_S16;
+#ifdef HAVE_OSS
+#include <stdio.h>
+#include <unistd.h>
+#include <fcntl.h>
+#include <sys/ioctl.h>
+#endif
 
 int err, dir;
 int resample = 1;
 unsigned int rate = 44100;
 unsigned int channels = 1;
-unsigned int buffer_time = 500000;
 unsigned int period_time = 100000;
 
+#ifdef HAVE_ALSA
+
+snd_pcm_format_t format = SND_PCM_FORMAT_S16;
+
+unsigned int buffer_time = 500000;
+
 snd_pcm_uframes_t buffer_size; //22050
 snd_pcm_uframes_t period_size; //4410
 
@@ -95,3 +105,30 @@
         }
 	return 0;
 }
+#endif
+
+#ifdef HAVE_OSS
+int format = AFMT_S16_LE;
+int period_size; //4410
+
+int oss_init(int audio_fd) {
+    period_size = 4096;
+    
+    if (ioctl(audio_fd, SNDCTL_DSP_SETFMT, &format) < 0) {
+        printf("Cannot set sample format\n");
+        return -1;
+    }
+    
+    if (ioctl(audio_fd, SNDCTL_DSP_CHANNELS, &channels) < 0) {
+        printf("Cannot set audio channels\n");
+        return -1;
+    }
+
+    if (ioctl(audio_fd, SNDCTL_DSP_SPEED, &rate) < 0) {
+        printf("Cannot set sample rate\n");
+        return -1;
+    }
+
+    return 0;
+}
+#endif
diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/src/sound.h 14-STYMulator-0.21a_configure+oss_support/src/sound.h
--- 13-STYMulator-0.21a-fail_on_bogus_data/src/sound.h	2010-04-21 19:03:35.121472984 +0200
+++ 14-STYMulator-0.21a_configure+oss_support/src/sound.h	2010-04-24 01:54:12.066624356 +0200
@@ -28,8 +28,21 @@
 #ifndef SOUND_H
 #define SOUND_H
 
+#ifdef HAVE_ALSA
 #include <alsa/asoundlib.h>
 
 int alsa_init(snd_pcm_t *pcm_handle, snd_pcm_hw_params_t *hwparams);
+extern snd_pcm_uframes_t period_size;
+#endif
+
+#ifdef HAVE_OSS
+
+#ifdef HAVE_SYS_SOUNDCARD_H
+#include <sys/soundcard.h>
+#endif
+
+int oss_init(int fd);
+extern int period_size;
+#endif
 
 #endif
diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/digidrum.cpp 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/digidrum.cpp
--- 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/digidrum.cpp	2010-04-22 10:03:36.403718119 +0200
+++ 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/digidrum.cpp	2010-04-24 01:38:14.617592991 +0200
@@ -29,6 +29,7 @@
 
 -----------------------------------------------------------------------------*/
 
+#include "config.h"
 #include "YmTypes.h"
 #include "digidrum.h"
 
diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/lzh/lzh.h 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/lzh/lzh.h
--- 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/lzh/lzh.h	2010-04-24 14:19:06.614646981 +0200
+++ 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/lzh/lzh.h	2010-04-24 14:19:20.270628134 +0200
@@ -47,7 +47,13 @@
 
 #else
 
+#ifdef HAVE_INTTYPES_H
+#include <inttypes.h>
+#endif
+
+#ifdef HAVE_STDINT_H
 #include <stdint.h>
+#endif
 
 typedef uint8_t  lzh_uchar;
 typedef uint16_t lzh_ushort;
diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/lzh/lzhlib.cpp 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/lzh/lzhlib.cpp
--- 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/lzh/lzhlib.cpp	2010-04-24 00:47:25.489581491 +0200
+++ 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/lzh/lzhlib.cpp	2010-04-24 01:39:15.605611328 +0200
@@ -31,6 +31,7 @@
 
 -----------------------------------------------------------------------------*/
 
+#include "config.h"
 #include <memory.h>
 #include "lzh.h"
 
diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/lzh/Makefile 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/lzh/Makefile
--- 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/lzh/Makefile	2010-04-23 15:06:20.379698377 +0200
+++ 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/lzh/Makefile	2010-04-25 12:53:36.669633844 +0200
@@ -1,10 +1,12 @@
 TOPDIR=../../..
 include $(TOPDIR)/Rules.make
 
+all: liblzh.a
+
 liblzh.a: lzhlib.o
 	$(AR) liblzh.a lzhlib.o
 
-lzhlib.o: lzhlib.cpp lzh.h
+lzhlib.o: lzhlib.cpp lzh.h $(TOPDIR)/config.h
 	$(CXX) $(CXXFLAGS) -c lzhlib.cpp
 
 clean:
diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/Makefile 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/Makefile
--- 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/Makefile	2010-04-24 00:47:11.609581406 +0200
+++ 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/Makefile	2010-04-25 12:55:58.305986655 +0200
@@ -3,22 +3,24 @@
 
 LIB = digidrum.o Ymload.o Ym2149Ex.o YmMusic.o YmUserInterface.o
 
+all: libym.a
+
 libym.a: $(LIB)
 	$(AR) libym.a $(LIB)
 
-digidrum.o: digidrum.cpp YmTypes.h
+digidrum.o: digidrum.cpp YmTypes.h $(TOPDIR)/config.h
 	$(CXX) $(CXXFLAGS) -c digidrum.cpp
 
-Ym2149Ex.o: Ym2149Ex.cpp Ym2149Ex.h YmTypes.h
+Ym2149Ex.o: Ym2149Ex.cpp Ym2149Ex.h YmTypes.h $(TOPDIR)/config.h
 	$(CXX) $(CXXFLAGS) -c Ym2149Ex.cpp
 
-Ymload.o: Ymload.cpp YmMusic.h lzh/lzh.h
+Ymload.o: Ymload.cpp YmMusic.h lzh/lzh.h $(TOPDIR)/config.h
 	$(CXX) $(CXXFLAGS) -c Ymload.cpp
 
-YmMusic.o: YmMusic.cpp YmMusic.h
+YmMusic.o: YmMusic.cpp YmMusic.h $(TOPDIR)/config.h
 	$(CXX) $(CXXFLAGS) -c YmMusic.cpp
 
-YmUserInterface.o: YmUserInterface.cpp StSoundLibrary.h YmMusic.h
+YmUserInterface.o: YmUserInterface.cpp StSoundLibrary.h YmMusic.h $(TOPDIR)/config.h
 	$(CXX) $(CXXFLAGS) -c YmUserInterface.cpp
 
 clean:
diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/Ym2149Ex.cpp 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/Ym2149Ex.cpp
--- 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/Ym2149Ex.cpp	2010-04-21 19:03:35.121472984 +0200
+++ 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/Ym2149Ex.cpp	2010-04-24 01:38:23.405595881 +0200
@@ -29,6 +29,7 @@
 
 -----------------------------------------------------------------------------*/
 
+#include "config.h"
 #include "YmTypes.h"
 #include <stdlib.h>
 #include <string.h>
diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/Ymload.cpp 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/Ymload.cpp
--- 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/Ymload.cpp	2010-04-25 12:19:13.358112601 +0200
+++ 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/Ymload.cpp	2010-04-25 12:20:22.000000000 +0200
@@ -28,11 +28,14 @@
 
 -----------------------------------------------------------------------------*/
 
+#include "config.h"
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 #include "YmMusic.h"
+#ifdef HAVE_LZH
 #include "lzh/lzh.h"
+#endif
 
 static	ymu16 ymVolumeTable[16] =
 {	62,161,265,377,580,774,1155,1575,2260,3088,4570,6233,9330,13187,21220,32767};
@@ -114,6 +117,7 @@
 			return mstrdup("");
 		}
 	}
+
 	p = mstrdup(*ptr);
 	(*ptr) += len+1;
         return p;
@@ -147,6 +151,9 @@
 
 unsigned char	*CYmMusic::depackFile(void)
  {
+#ifndef HAVE_LZH
+	return pBigMalloc;
+#else
  lzhHeader_t *pHeader;
  ymu8	*pNew;
  ymu8	*pSrc;
@@ -217,6 +224,7 @@
 		}
 
 		return pNew;
+#endif
  }
 
 
diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/YmMusic.cpp 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/YmMusic.cpp
--- 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/YmMusic.cpp	2010-04-22 10:03:20.472686871 +0200
+++ 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/YmMusic.cpp	2010-04-24 01:38:42.585610175 +0200
@@ -28,6 +28,7 @@
 
 -----------------------------------------------------------------------------*/
 
+#include "config.h"
 #include <string.h>
 #include <stdlib.h>
 #include "YmMusic.h"
diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/YmTypes.h 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/YmTypes.h
--- 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/YmTypes.h	2010-04-21 19:03:35.121472984 +0200
+++ 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/YmTypes.h	2010-04-24 01:36:25.465743913 +0200
@@ -63,7 +63,13 @@
 
 #else
 
+#ifdef HAVE_INTTYPES_H
+#include <inttypes.h>
+#endif
+
+#ifdef HAVE_STDINT_H
 #include <stdint.h>
+#endif
 
 #ifdef YM_INTEGER_ONLY
 typedef		int64_t  yms64;
diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/YmUserInterface.cpp 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/YmUserInterface.cpp
--- 13-STYMulator-0.21a-fail_on_bogus_data/src/stsoundlib/YmUserInterface.cpp	2010-04-21 19:03:35.121472984 +0200
+++ 14-STYMulator-0.21a_configure+oss_support/src/stsoundlib/YmUserInterface.cpp	2010-04-24 01:38:52.186581117 +0200
@@ -28,7 +28,7 @@
 
 -----------------------------------------------------------------------------*/
 
-
+#include "config.h"
 #include "YmMusic.h"
 #include "StSoundLibrary.h"
 
diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/src/ui.cpp 14-STYMulator-0.21a_configure+oss_support/src/ui.cpp
--- 13-STYMulator-0.21a-fail_on_bogus_data/src/ui.cpp	2010-04-21 19:03:35.121472984 +0200
+++ 14-STYMulator-0.21a_configure+oss_support/src/ui.cpp	2010-04-24 01:37:33.097620468 +0200
@@ -32,6 +32,7 @@
 #define PLATFORM 0
 #endif
 
+#include "config.h"
 #include "stsoundlib/StSoundLibrary.h"
 #include "ui.h"
 #include <stdlib.h>
diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/src/ym2wav.cpp 14-STYMulator-0.21a_configure+oss_support/src/ym2wav.cpp
--- 13-STYMulator-0.21a-fail_on_bogus_data/src/ym2wav.cpp	2010-04-21 19:03:35.121472984 +0200
+++ 14-STYMulator-0.21a_configure+oss_support/src/ym2wav.cpp	2010-04-24 01:37:43.135194828 +0200
@@ -35,6 +35,7 @@
 #define PLATFORM 0
 #endif
 
+#include "config.h"
 #include	<stdlib.h>
 #include	<stdio.h>
 #include	"stsoundlib/StSoundLibrary.h"
diff -urN 13-STYMulator-0.21a-fail_on_bogus_data/src/ymplayer.cpp 14-STYMulator-0.21a_configure+oss_support/src/ymplayer.cpp
--- 13-STYMulator-0.21a-fail_on_bogus_data/src/ymplayer.cpp	2010-04-21 19:03:35.121472984 +0200
+++ 14-STYMulator-0.21a_configure+oss_support/src/ymplayer.cpp	2010-04-24 01:54:46.553624361 +0200
@@ -32,15 +32,20 @@
 #define PLATFORM 0
 #endif
 
+#include "config.h"
 #include "stsoundlib/StSoundLibrary.h"
 #include "ui.h"
 #include "sound.h"
-#include <alsa/asoundlib.h>
+#ifdef HAVE_OSS
+#include <sys/ioctl.h>
+#include <unistd.h>
+#include <fcntl.h>
+#include <errno.h>
+#endif
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
 
-extern snd_pcm_uframes_t period_size;
 bool digi;
 
 int main(int argc, char **argv)
@@ -69,20 +74,27 @@
 		return -1;
 	}
 
+#ifdef HAVE_ALSA
 	snd_pcm_t *pcm_handle;
 	snd_pcm_hw_params_t *hwparams;
 	snd_pcm_hw_params_alloca(&hwparams);
 
+	snd_output_t *output = NULL;
+	char pcm_name[] = "default";
 	int err;
+#endif
+#ifdef HAVE_OSS
+	int audio_fd;
+	char pcm_name[] = "/dev/dsp";
+#endif	
+
 	unsigned int buf;
 
-	snd_output_t *output = NULL;
-	char pcm_name[] = "default";
 
 	YMMUSIC *pMusic = ymMusicCreate();
 
 	if (ymMusicLoad(pMusic,argv[1])) {
-
+#ifdef HAVE_ALSA
 		if ((err = snd_output_stdio_attach(&output, stdout, 0)) < 0) {
 			printf("Output failed: %s\n", snd_strerror(err));
 			return 0;
@@ -95,6 +107,17 @@
 			printf("Setting of hwparams failed: %s\n", snd_strerror(err));
 			exit(EXIT_FAILURE);
 		}
+#endif
+#ifdef HAVE_OSS
+		if ((audio_fd = open(pcm_name, O_WRONLY)) < 0) {
+			printf("device open error: %s\n", strerror(errno));
+			return 0;
+		}
+		if (oss_init(audio_fd) < 0) {
+			printf("Setting of hwparams failed: %s\n", strerror(errno));
+			exit(EXIT_FAILURE);
+		}
+#endif
 
 		buf = period_size;
 		ymsample *convertBuffer = new ymsample[buf];
@@ -112,7 +135,7 @@
 			playing = ymMusicCompute(pMusic,convertBuffer, buf);
 			if (digi)
 				draw_time(ymMusicGetPos(pMusic) / 1000);
-
+#ifdef HAVE_ALSA
 			if ((err = snd_pcm_writei(pcm_handle, convertBuffer, buf)) == -EPIPE) {
 				err = snd_pcm_prepare(pcm_handle);
 			} else if (err == -ESTRPIPE) {
@@ -122,6 +145,12 @@
 					err = snd_pcm_prepare(pcm_handle);
 				}
 			}
+#endif
+#ifdef HAVE_OSS
+			if (write(audio_fd, convertBuffer, buf*2) < 0) {
+				perror("audio device not ready for data");
+			}
+#endif
 			switch(getch()) {
 				case 27: case 'q':	quit = true; break;
 				case 'z':	pmode = true;	break; //play
@@ -182,7 +211,12 @@
 		}	
 	
 		ymMusicStop(pMusic);
+#ifdef HAVE_ALSA
 		snd_pcm_close(pcm_handle);
+#endif
+#ifdef HAVE_OSS
+		close(audio_fd);
+#endif
 		delete convertBuffer;
 		ui_end();
 
